//Verwaltung einer Liste:
// - beinhaltet eine Liste und Methoden zu deren Manipulation

class Container
{
  public:
    //Aus praktischen Grnden bleibt typischerweise 
    //das Kopfelement "leer" und erst bei Anfgen des
    //ersten weiteren Listenelements soll die Liste
    //"ein Element" besitzen.
    Fahrzeug* kopf; //erstes Element der Liste.

    Container()
    {
        kopf = new Fahrzeug();
    }
 
    Fahrzeug* findeLetztesElement()
    {
        Fahrzeug* aktuell = kopf;
        while(aktuell->nachfolger!=0)
            aktuell=(aktuell->nachfolger);
        return aktuell;
    }

    //..soll mglichst einfach in der Benutzung sein:
    void append(string kennzeichen, string wagentyp)
    {
        //1. neues Fahrzeug-Objekt erstellen.
        Fahrzeug* neuesFahrzeug = new Fahrzeug();
        //2. ..diesem Kennzeichen und Typ bergeben (darin speichern)
        neuesFahrzeug->kennzeichen = kennzeichen;
        neuesFahrzeug->wagentyp = wagentyp;
        //3. Zeigerzuweisung an der richtigen Stelle (?)
        //So ginge es, wenn es sich um das erste Element 
        //handelte:
        //kopf->nachfolger = neuesFahrzeug;
        //Sonst brauchen wir immer das letzte, hinterste Element!

        //3a Ende suchen
        Fahrzeug* ende = findeLetztesElement();
        //3b ende.nachfolger soll neues Element sein.
        ende->nachfolger = neuesFahrzeug;
    }

    void zeigeListe()
    {
        Fahrzeug* aktuell = kopf;
        while(aktuell->nachfolger!=0)
        {
            aktuell=(aktuell->nachfolger);
            cout<<aktuell->wagentyp<<" "<<aktuell->kennzeichen<<endl;
        }
    }
};

