import java.applet.Applet;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class Schieberapplet extends Applet implements Runnable  //NEU
{
    double BREITE = 400.0;
    double HOEHE = 400.0;

    int[] farben = {0,0,0}; //rot grün blau
    
    double[][] y_scale = null;
    double[]   t_scale = null;
    
    //Test der neuen Scroll-Klasse
    double[] parameter = {0.0,0.0,0.0};
    Simulator simulator = new Simulator();

//NEU:    
    public boolean AKTIV = false;
    public int INDEX=0;
    public void run()
    {
        while(true)
        {
           if(AKTIV==true)            
           {
            try
            {
                Thread.sleep(100);
            }
            catch(Exception e)
            {
            }
            if(INDEX>=y_scale[0].length)
            {
                INDEX=0;
                AKTIV=false;
            }
            else
            {                
                INDEX+=4;
                repaint(); //Auffrischen der Darstellung (paint() wird bei nächster Gelegenheit aufgerufen)
            }
           } 
        }
    }


    public void init()
    {
        setLayout(null);
        //setBackground(new Color(255,255,255)); //weiss
        
        Scroll s1 = new Scroll(0,0,520,"C N/m",0.0,10.0,parameter,simulator,this);
        add(s1);
        Scroll s2 = new Scroll(1,0,520,"D Ns/m",0.0,10.0,parameter,simulator,this);
        add(s2);
        
        Button knopf = new Button("Animation");
        knopf.setBounds(300,580,120,30);
        knopf.addActionListener(new Knopflauscher());
        add(knopf);
        
        (new Thread(this)).start();
    }

    public void paint(Graphics g)
    {
        g.setColor(new Color(0,0,255)); //blau
        
        if(y_scale==null || t_scale==null)
        {
            t_scale = new double[simulator.tt.length];
            y_scale = new double[simulator.y.length][simulator.y[0].length];
        }
        
        //Min und Max
        double tmin = simulator.tt[0];
        double tmax = simulator.tt[0];

        double ymin = simulator.y[0][0];
        double ymax = simulator.y[0][0];
        
        for(int i=0;i<simulator.tt.length;i++)
        {
            if(simulator.tt[i]>tmax) tmax = simulator.tt[i];
            if(simulator.tt[i]<tmin) tmin = simulator.tt[i];
        }

        for(int i=0;i<simulator.y[0].length;i++)
        {
            if(simulator.y[0][i]>ymax) ymax = simulator.y[0][i];
            if(simulator.y[0][i]<ymin) ymin = simulator.y[0][i];
        }
        
        if(tmin<tmax && ymin<ymax) //nur weitermachen, wenn Simulation bereits erfolgt
        {
System.out.println("tmin="+tmin);            
System.out.println("tmax="+tmax);            
System.out.println("ymin="+ymin);            
System.out.println("ymax="+ymax);            
            
            for(int i=0;i<y_scale[0].length;i++)
                y_scale[0][i] = HOEHE*(simulator.y[0][i]-ymin)/(ymax-ymin);
            for(int i=0;i<t_scale.length;i++)
                t_scale[i] = BREITE*(simulator.tt[i]-tmin)/(tmax-tmin);

            for(int i=0;i<y_scale[0].length;i++)
                y_scale[0][i] = HOEHE - y_scale[0][i];
                
                
//NEU Animation darstellen:        
            if(y_scale!=null && AKTIV==true)
            {
                g.setColor(Color.RED);
                g.fillOval(410,(int)y_scale[0][INDEX],40,40);
            }
            
            if(AKTIV==false)
            {
g.setColor(new Color(0,0,255)); //blau
            for(int i=0;i<t_scale.length-1;i++)
            {
                
                g.drawLine(
                          (int)t_scale[i],(int)y_scale[0][i],
                          (int)t_scale[i+1],(int)y_scale[0][i+1]
                        );                       
            }
            }
            
        }
        
        
        
    }

//NEU Lauscher für den Knopf
    public class Knopflauscher implements ActionListener
    {
        public void actionPerformed(ActionEvent ee)
        {
            INDEX=0;
            AKTIV=true;
        }
    }
    
    public class Lauscher implements AdjustmentListener
    {
        private int index;
        
        public Lauscher(int index)
        {
              this.index = index;
        }
        
        public void adjustmentValueChanged(AdjustmentEvent event)
        {
            int position = event.getValue();
            farben[index] = position;
            repaint();
        }
    }
}