import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class Darstellung extends PApplet
{
    int position = 0;
    boolean AKTIV=false;
    Button knopf;
    JButton knopf2;
    
    public void setup()
    {
        setLayout(null);
        knopf = new Button("Animation");
        knopf.setBounds(10,300,120,30);
        knopf.addActionListener(new Knopflauscher());
        add(knopf);

        knopf2 = new JButton("Animation2");
        knopf2.setBounds(140,300,120,30);
        knopf2.addActionListener(new Knopflauscher());
        add(knopf2);
        
        
        size(500,500);
        frameRate(25);
    }

    public void draw()
    {
        clear();

        
        fill(255,0,0);
        noStroke();
        rect(10+position,20,50,50);
        
        if(AKTIV)
        {
            position++;
            position%=100;
        }
        knopf.repaint();
        knopf2.repaint();
    }
    
    private class Knopflauscher implements ActionListener
    {
        public void actionPerformed(ActionEvent ee)
        {
            AKTIV=!AKTIV;
        }        
    }
    
    public static void main(String[] passedArgs) 
    {
        String[] appletArgs = new String[] { "Darstellung" };
        if(passedArgs != null) 
        {
             PApplet.main(concat(appletArgs, passedArgs));
        } 
        else 
        {
            PApplet.main(appletArgs);
        }            
    }
}
